fix bug in turning off auto-decrypt
[automated-distro-installer] / chboot
diff --git a/chboot b/chboot
index 37d2516bb1cf941753a949b6ff9a0259b4592470..884b2a55f80478fb6f0f0d47c489efc1b8bde5ab 100755 (executable)
--- a/chboot
+++ b/chboot
@@ -1,18 +1,22 @@
-#!/bin/bash -x
+#!/bin/bash
 
 # Set grub to boot into a different distro, and reboot unless -r
-# $0 DISTRO_NAME
+# $0 [DISTRO_NAME]
+# with no argument, print available distros
 
 # DISTRO_NAME is based on the partition names in /boot. eg boot_debianjessie
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo "$BASH_SOURCE" "$@"
 
+
+###### begin command line parsing #####
 reboot=true
 while [[ $1 == -* ]]; do
     case $1 in
+        -d) set -x; shift ;;
         -r) reboot=false; shift ;;
         --) break ;;
     esac
@@ -21,14 +25,25 @@ done
 
 distro=$1
 
+if [[ ! $distro ]]; then
+    echo "available distros:"
+    btrfs subvolume list /boot | sed -rn 's/^.*boot_(.*)/\1/p'
+    exit 0
+fi
+
 ###### end command line parsing #####
 
+
+#### begin initial error checking #####
+
 if ! btrfs subvolume list /boot | grep "_$distro$" &>/dev/null; then
     echo "$0: error: _$distro$ not found in btrfs subvolume list /boot:"
     btrfs subvolume list /boot
     exit 1
 fi
 
+#### end initial error checking #####
+
 e() { echo "$@"; "$@"; }
 
 boot_dev=$(mount | sed -rn "s#^(\S+) on /boot .*#\1#p")
@@ -46,3 +61,8 @@ e grub-bios-setup -d $mount_point/grub/i386-pc -s -m $mount_point/grub/device.ma
 
 e umount $mount_point
 e rmdir $mount_point
+
+if $reboot; then
+    touch /tmp/keyscript-off
+    reboot now
+fi